#include <time.h>
#include "cgic.h"
#include "tracker.h"

extern int cgiMain(void)
{
	MYSQL mysql;
	MYSQL_RES *mysqlresult;
	MYSQL_ROW mysqlrow;
    struct ayr ayarlar;
	unsigned int num_rows, i;
	char query[512];
	int mysql_durum;
	int total=0;
	time_t	curtime;
	struct tm *tmb;
	
	time(&curtime);
	tmb = localtime(&curtime);

    cgiHeaderContentType("text/html");
    fprintf(cgiOut, "<html><head><title>Network Devices in Stock-- Ali BASEL</title></head><body bgcolor=\"#D9D9D9\">");
	fprintf(cgiOut, "<center><h2>Network Devices in Stock</h2>");
	
	openlog("trackercgi", LOG_NOWAIT,  LOG_LOCAL1);
    
	/* Reads sql hostname, username and password from CONFIG_FILE file */
    if( !config_oku(&ayarlar) ) {
        printf("Please look at syslog message file for the error !\n\n");
        exit(0);
    }
    
	
    mysql_init(&mysql);
    if(!mysql_real_connect(&mysql, ayarlar.sqlhost, ayarlar.sqluser, ayarlar.sqlpass, ayarlar.sqldb, SQLPORT, NULL, 0)) {
        syslog(LOG_INFO, "Error:%s, Query:%s\n", mysql_error(&mysql), query);
        exit(0);
	}

	
	sprintf(query, "select count(*), ModelNo, Aciklama,GEPortSayisi, FEPortSayisi  from StockModules where MainSerialNo!='bozuklar' group by 2 order by 2");
    #ifdef DEBUG
	    syslog(LOG_INFO, "Find the defective devices in the database: query=%s\n", query);
    #endif
	mysql_durum=mysql_real_query(&mysql, query, strlen(query));
	if( mysql_durum ) {
		syslog(LOG_INFO, "Error:%s, Query:%s\n", mysql_error(&mysql), query);
		exit(0);
	}
	else { // query succeeded, process any data returned by it
		mysqlresult = mysql_store_result(&mysql);
        num_rows = mysql_num_rows(mysqlresult);
		#ifdef DEBUG
		    syslog(LOG_INFO, " number of rows:%d\n", num_rows);
        #endif
		if( num_rows ) {
			fprintf(cgiOut, "<table border=1><tr><td>Count</td><td>Model No</td><td>Remarque</td><td>GE Port Number</td><td>FE Port Number</td></tr>\n");
			for(i=0; i<num_rows; i++) {
				mysqlrow = mysql_fetch_row(mysqlresult);
				fprintf(cgiOut, "<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n", mysqlrow[0], mysqlrow[1], mysqlrow[2], mysqlrow[3], mysqlrow[4]);
				total+=atoi(mysqlrow[0]);
			}
            mysql_free_result(mysqlresult);
		}
	}

	if( !num_rows) {
		syslog(LOG_INFO, "There is no defective device in the database !");
		exit(0);
	}
	mysql_close(&mysql);
	
	fprintf(cgiOut, "</table>");
	fprintf(cgiOut, "<h4>Total Device Number in Stock: %d  --  [%2d:%2d:%4d][%d:%d:%d]</h4>\n", total, tmb->tm_mday, tmb->tm_mon+1, tmb->tm_year+1900, tmb->tm_hour, tmb->tm_min, tmb->tm_sec);
	fprintf(cgiOut, "</center></html>");	
	return(1);
}
